searchNodes=[{"doc":"Functions for writing commits to the changelog, and initializing it.","ref":"GitOps.Changelog.html","title":"GitOps.Changelog","type":"module"},{"doc":"","ref":"GitOps.Changelog.html#initialize/2","title":"GitOps.Changelog.initialize/2","type":"function"},{"doc":"","ref":"GitOps.Changelog.html#write/5","title":"GitOps.Changelog.write/5","type":"function"},{"doc":"Manages the structure, parsing, and formatting of commits. Using parse/1 you can parse a commit struct out of a commit message Using format/1 you can format a commit struct in the way that the changelog expects.","ref":"GitOps.Commit.html","title":"GitOps.Commit","type":"module"},{"doc":"","ref":"GitOps.Commit.html#breaking?/1","title":"GitOps.Commit.breaking?/1","type":"function"},{"doc":"","ref":"GitOps.Commit.html#feature?/1","title":"GitOps.Commit.feature?/1","type":"function"},{"doc":"","ref":"GitOps.Commit.html#fix?/1","title":"GitOps.Commit.fix?/1","type":"function"},{"doc":"","ref":"GitOps.Commit.html#format/1","title":"GitOps.Commit.format/1","type":"function"},{"doc":"","ref":"GitOps.Commit.html#parse/1","title":"GitOps.Commit.parse/1","type":"function"},{"doc":"","ref":"GitOps.Commit.html#t:t/0","title":"GitOps.Commit.t/0","type":"type"},{"doc":"Helpers around fetching configurations, including setting defaults.","ref":"GitOps.Config.html","title":"GitOps.Config","type":"module"},{"doc":"","ref":"GitOps.Config.html#changelog_file/0","title":"GitOps.Config.changelog_file/0","type":"function"},{"doc":"","ref":"GitOps.Config.html#manage_mix_version?/0","title":"GitOps.Config.manage_mix_version?/0","type":"function"},{"doc":"","ref":"GitOps.Config.html#manage_readme_version/0","title":"GitOps.Config.manage_readme_version/0","type":"function"},{"doc":"","ref":"GitOps.Config.html#mix_project/0","title":"GitOps.Config.mix_project/0","type":"function"},{"doc":"","ref":"GitOps.Config.html#mix_project_check/1","title":"GitOps.Config.mix_project_check/1","type":"function"},{"doc":"","ref":"GitOps.Config.html#prefix/0","title":"GitOps.Config.prefix/0","type":"function"},{"doc":"","ref":"GitOps.Config.html#repository_path/0","title":"GitOps.Config.repository_path/0","type":"function"},{"doc":"","ref":"GitOps.Config.html#repository_url/0","title":"GitOps.Config.repository_url/0","type":"function"},{"doc":"","ref":"GitOps.Config.html#types/0","title":"GitOps.Config.types/0","type":"function"},{"doc":"Helper functions for working with Git and fetching the tags/commits we care about.","ref":"GitOps.Git.html","title":"GitOps.Git","type":"module"},{"doc":"","ref":"GitOps.Git.html#add!/2","title":"GitOps.Git.add!/2","type":"function"},{"doc":"","ref":"GitOps.Git.html#commit!/2","title":"GitOps.Git.commit!/2","type":"function"},{"doc":"","ref":"GitOps.Git.html#commit_messages_since_tag/2","title":"GitOps.Git.commit_messages_since_tag/2","type":"function"},{"doc":"","ref":"GitOps.Git.html#get_initial_commits!/1","title":"GitOps.Git.get_initial_commits!/1","type":"function"},{"doc":"","ref":"GitOps.Git.html#hooks_path/1","title":"GitOps.Git.hooks_path/1","type":"function"},{"doc":"","ref":"GitOps.Git.html#init!/1","title":"GitOps.Git.init!/1","type":"function"},{"doc":"","ref":"GitOps.Git.html#tag!/2","title":"GitOps.Git.tag!/2","type":"function"},{"doc":"","ref":"GitOps.Git.html#tags/1","title":"GitOps.Git.tags/1","type":"function"},{"doc":"Functionality around parsing and comparing versions contained in git tags","ref":"GitOps.Version.html","title":"GitOps.Version","type":"module"},{"doc":"","ref":"GitOps.Version.html#determine_new_version/5","title":"GitOps.Version.determine_new_version/5","type":"function"},{"doc":"","ref":"GitOps.Version.html#last_valid_non_rc_version/2","title":"GitOps.Version.last_valid_non_rc_version/2","type":"function"},{"doc":"","ref":"GitOps.Version.html#last_valid_version/2","title":"GitOps.Version.last_valid_version/2","type":"function"},{"doc":"","ref":"GitOps.Version.html#last_version_greater_than/3","title":"GitOps.Version.last_version_greater_than/3","type":"function"},{"doc":"Functions that handle the logic behind replacing the version in related files.","ref":"GitOps.VersionReplace.html","title":"GitOps.VersionReplace","type":"module"},{"doc":"","ref":"GitOps.VersionReplace.html#update_mix_project/4","title":"GitOps.VersionReplace.update_mix_project/4","type":"function"},{"doc":"","ref":"GitOps.VersionReplace.html#update_readme/4","title":"GitOps.VersionReplace.update_readme/4","type":"function"},{"doc":"Receives a file path and validates if it's content follows the Conventional Commits specification. mix git_ops . check_message &lt; path / to / file &gt; Logs an error if the commit message is not parse-able. See https://www.conventionalcommits.org/en/v1.0.0/ for more details on Conventional Commits.","ref":"Mix.Tasks.GitOps.CheckMessage.html","title":"Mix.Tasks.GitOps.CheckMessage","type":"task"},{"doc":"Installs a Git commit-msg hook to automatically check if the commit message follows the Conventional Commits spec: mix git_ops . message_hook The actual check is done by using the git_ops.check_message mix task: mix git_ops . check_message / path / to / commit / message / file It does nothing if a Git commit-msg hook already exists that contains the above message validation task (unless --force was used). Logs an error if a Git commit-msg hook exists but it does not call the message validation task. Switches: --force|-f - Overwrites the Git commit-msg hook if one exists but it does not call the message validation task. --uninstall - Uninstalls the git commit-msg hook if it exists. --verbose|-v - Be more verbose. Pass this option twice to be even more verbose.","ref":"Mix.Tasks.GitOps.MessageHook.html","title":"Mix.Tasks.GitOps.MessageHook","type":"task"},{"doc":"A handy helper which prints out the app name and version number. May be useful in your CI system. mix git_ops . project_info Switches: --format|-f selects the output format. Currently suported output formats are json , toml , github-actions , shell and dotenv .","ref":"Mix.Tasks.GitOps.ProjectInfo.html","title":"Mix.Tasks.GitOps.ProjectInfo","type":"task"},{"doc":"Updates project changelog, and any other configured release capabilities. mix git_ops . release Logs an error for any commits that were not parseable. In the case that the prior version was a pre-release and this one is not, the version is only updated via removing the pre-release identifier. For more information on semantic versioning, including pre release and build identifiers, see the specification here: https://semver.org/ Switches: --initial - Creates the first changelog, and sets the version to whatever the configured mix project's version is. --pre-release - Sets this release to be a pre release, using the configured string as the pre release identifier. This is a manual process, and results in an otherwise unchanged version. (Does not change the minor version). The version number will only change if a higher version number bump is required than what was originally changed in the creation of the RC. For instance, if patch was changed when creating the pre-release, and no fixes or features were added when requesting a new pre-release, then the version will not change. However, if the last pre-release had only a patch version bump, but a major change has since been added, the version will be changed accordingly. --rc - Overrides the presence of --pre-release , and manages an incrementing identifier as the prerelease. This will look like 1.0.0-rc0 1.0.0-rc1 and so forth. See the --pre-release flag for information on when the version will change for a pre-release. In the case that the version must change, the counter for the release candidate counter will be reset as well. --build - Sets the release build metadata. Build information has no semantic meaning to the version itself, and so is simply attached to the end and is to be used to describe the build conditions for that release. You might build the same version many times, and this can be used to denote that in whatever way you choose. --force-patch - In cases where this task is run, but the version should not change, this option will force the patch number to be incremented. --no-major - Forces major version changes to instead only result in minor version changes. This would be a common option for libraries that are still in 0.x.x phases where 1.0.0 should only happen at some specified milestones. After that, it is important to not resist a 2.x.x change just because it doesn't seem like it deserves it. Semantic versioning uses this major version change to communicate, and it should not be reserved. --dry-run - Allow users to run release process and view changes without committing and tagging --yes - Don't prompt for confirmation, just perform release. Useful for your CI run.","ref":"Mix.Tasks.GitOps.Release.html","title":"Mix.Tasks.GitOps.Release","type":"task"},{"doc":"A small tool to help generate changelogs from conventional commit messages. For more information, see conventional commits . For an example, see this project's CHANGELOG.md . Roadmap (in no particular order): More tests Automatically parse issue numbers and github mentions into the correct format, linking the issue A task to build a compliant commit Validation of commits Automatically link to the PR that merged a given commit in the changelog A hundred other things I forgot to write down while writing the initial version Important addendums: A new version of the spec in beta adds a rather useful convention. Add ! after the type/scope to simply signal it as a breaking change, instead of adding BREAKING CHANGE: description in your commit message. For example: fix(Spline Reticulator)!: The spec doesn't specify behavior around multiple scopes. This library parses scopes as a comma separated list . This allows for easily readable multiple word lists feat(Something Special, Something Else Special): message . Keep in mind that you are very limited on space in these messages, and if you find yourself using multiple scopes your commit is probably too big.","ref":"readme.html","title":"GitOps","type":"extras"},{"doc":"def deps do [ { :git_ops , &quot;~&gt; 2.5.1&quot; , only : [ :dev ] } ] end","ref":"readme.html#installation","title":"GitOps - Installation","type":"extras"},{"doc":"config :git_ops , mix_project : Mix.Project . get! ( ) , changelog_file : &quot;CHANGELOG.md&quot; , repository_url : &quot;https://github.com/my_user/my_repo&quot; , types : [ # Makes an allowed commit type called `tidbit` that is not # shown in the changelog tidbit : [ hidden? : true ] , # Makes an allowed commit type called `important` that gets # a section in the changelog with the header &quot;Important Changes&quot; important : [ header : &quot;Important Changes&quot; ] ] , # Instructs the tool to manage your mix version in your `mix.exs` file # See below for more information manage_mix_version? : true , # Instructs the tool to manage the version in your README.md # Pass in `true` to use `&quot;README.md&quot;` or a string to customize manage_readme_version : &quot;README.md&quot; , version_tag_prefix : &quot;v&quot; Getting started: mix git_ops.release --initial Commit the result of that, using a message like chore: Initial Release Then when you want to release again, use: mix git_ops.release For the full documentation of that task, see the task documentation in hex.","ref":"readme.html#configuration","title":"GitOps - Configuration","type":"extras"},{"doc":"To have mix manage your mix version, add manage_mix_version?: true to your configuration. Then, use a module attribute called @version to manage your application's version. Look at this project's mix.exs for an example.","ref":"readme.html#managing-your-mix-version","title":"GitOps - Managing your mix version","type":"extras"},{"doc":"Most project readmes have a line like this that would ideally remain up to date: { :git_ops , &quot;~&gt; 2.5.1&quot; , only : [ :dev ] } You can keep that number up to date via manage_readme_version , which accepts true for README.md or a string pointing to some other path relative to your project root.","ref":"readme.html#managing-your-readme-version","title":"GitOps - Managing your readme version","type":"extras"},{"doc":"If you'd like your contributors to use the conventional commit format, you can use a PULL_REQUEST_TEMPLATE.md like ours. However, it is also possible to manage it as the maintainers of a project by altering either the merge commit or alter the commit when merging/squashing (recommended)","ref":"readme.html#using-this-with-open-source-projects","title":"GitOps - Using this with open source projects","type":"extras"},{"doc":"https://github.com/glasnoster/eliver https://github.com/oo6/mix-bump https://github.com/mpanarin/versioce","ref":"readme.html#similar-projects","title":"GitOps - Similar projects","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. See Conventional Commits for commit guidelines.","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"Improvements: handle incrementing rc versions more gracefully","ref":"changelog.html#v2-5-1-2022-10-04","title":"Change Log - v2.5.1 (2022-10-04)","type":"extras"},{"doc":"Features: configurable git repository root (#53) Improvements: add tracking multiple &quot;readme&quot; file for versions","ref":"changelog.html#v2-5-0-2022-09-28","title":"Change Log - v2.5.0 (2022-09-28)","type":"extras"},{"doc":"Bug Fixes: more rc fixes track rcs properly","ref":"changelog.html#v2-4-5-2021-07-18","title":"Change Log - v2.4.5 (2021-07-18)","type":"extras"},{"doc":"Bug Fixes: use properly sortable rc numbering","ref":"changelog.html#v2-4-4-2021-06-24","title":"Change Log - v2.4.4 (2021-06-24)","type":"extras"},{"doc":"Bug Fixes: use rc tags for rc releases","ref":"changelog.html#v2-4-3-2021-06-04","title":"Change Log - v2.4.3 (2021-06-04)","type":"extras"},{"doc":"Bug Fixes: replace headings properly Improvements: clean empty lines in tag message","ref":"changelog.html#v2-4-2-2021-01-08","title":"Change Log - v2.4.2 (2021-01-08)","type":"extras"},{"doc":"Bug Fixes: remove heading hashes escape headers in tag message","ref":"changelog.html#v2-4-1-2021-01-08","title":"Change Log - v2.4.1 (2021-01-08)","type":"extras"},{"doc":"Features: Include changelog notes to release tag message (#44)","ref":"changelog.html#v2-4-0-2021-01-08","title":"Change Log - v2.4.0 (2021-01-08)","type":"extras"},{"doc":"Features: project_info_dotenv_format: Add the dotenv format for project info output. (#42)","ref":"changelog.html#v2-3-0-2020-12-28","title":"Change Log - v2.3.0 (2020-12-28)","type":"extras"},{"doc":"Features: project_info_task: Add git_ops.project_info task. (#41) yes: Add --yes flag to mix get_ops.release (#38)","ref":"changelog.html#v2-2-0-2020-12-15","title":"Change Log - v2.2.0 (2020-12-15)","type":"extras"},{"doc":"Features: yes: Add --yes flag to mix get_ops.release (#38)","ref":"changelog.html#v2-1-0-2020-11-21","title":"Change Log - v2.1.0 (2020-11-21)","type":"extras"},{"doc":"Bug Fixes: messaging, and changelog ranges","ref":"changelog.html#v2-0-2-2020-11-19","title":"Change Log - v2.0.2 (2020-11-19)","type":"extras"},{"doc":"Bug Fixes: messaging, and changelog ranges","ref":"changelog.html#v2-0-1-2020-07-24","title":"Change Log - v2.0.1 (2020-07-24)","type":"extras"},{"doc":"Breaking Changes: parse multiple messages","ref":"changelog.html#v2-0-0-2020-03-25","title":"Change Log - v2.0.0 (2020-03-25)","type":"extras"},{"doc":"Bug Fixes: use prefix on initial version Bug Fixes: Skipped for operational reasons Bug Fixes: Move version tag parsing logic Fix tag order from git tag function. Performance Improvements: Save an iteration in the map+join (#29)","ref":"changelog.html#v1-1-3-2020-03-17","title":"Change Log - v1.1.3 (2020-03-17)","type":"extras"},{"doc":"Features: commit message validation","ref":"changelog.html#v1-1-0-2020-02-06","title":"Change Log - v1.1.0 (2020-02-06)","type":"extras"},{"doc":"Breaking Changes: fail on prefixed ! and support postfixed ! (#22)","ref":"changelog.html#v1-0-0-2019-12-4","title":"Change Log - v1.0.0 (2019-12-4)","type":"extras"},{"doc":"Bug Fixes: --initial --dry-run creates Changelog (#18) (#19)","ref":"changelog.html#v0-6-4-2019-12-4","title":"Change Log - v0.6.4 (2019-12-4)","type":"extras"},{"doc":"Bug Fixes: explicitly add changelog","ref":"changelog.html#v0-6-3-2019-8-19","title":"Change Log - v0.6.3 (2019-8-19)","type":"extras"},{"doc":"Bug Fixes: log less, and accept unicode","ref":"changelog.html#v0-6-2-2019-8-19","title":"Change Log - v0.6.2 (2019-8-19)","type":"extras"},{"doc":"Improvements: support additional commit types by default","ref":"changelog.html#v0-6-1-2019-7-12","title":"Change Log - v0.6.1 (2019-7-12)","type":"extras"},{"doc":"Features: dry_run release option Bug Fixes: allow no prefix initial mix project check (#6)","ref":"changelog.html#v0-6-0-2019-1-22","title":"Change Log - v0.6.0 (2019-1-22)","type":"extras"},{"doc":"Features: calculate new version from project instead of tags","ref":"changelog.html#v0-5-0-2018-11-20","title":"Change Log - v0.5.0 (2018-11-20)","type":"extras"},{"doc":"Bug Fixes: correctly handle already parsed versions","ref":"changelog.html#v0-4-1-2018-11-16","title":"Change Log - v0.4.1 (2018-11-16)","type":"extras"},{"doc":"Features: Allow configuring a version prefix Bug Fixes: messaging and tag prefix prefix is the first argument to parse!/2 fix error when version struct not expected resolve issue with comparing invalid version","ref":"changelog.html#v0-4-0-2018-11-16","title":"Change Log - v0.4.0 (2018-11-16)","type":"extras"},{"doc":"Bug Fixes: Fail better when mix_project is not set","ref":"changelog.html#0-3-4-2018-10-15","title":"Change Log - 0.3.4 (2018-10-15)","type":"extras"},{"doc":"Bug Fixes: don't fail on unparseable commit during init","ref":"changelog.html#0-3-3-2018-10-11","title":"Change Log - 0.3.3 (2018-10-11)","type":"extras"},{"doc":"Bug Fixes: depend on correct version of nimble_parsec","ref":"changelog.html#0-3-2-2018-10-11","title":"Change Log - 0.3.2 (2018-10-11)","type":"extras"},{"doc":"Bug Fixes: depend on correct version of nimble_parsec","ref":"changelog.html#0-3-2-2018-10-11","title":"Change Log - 0.3.2 (2018-10-11)","type":"extras"},{"doc":"Bug Fixes: use annotated tags","ref":"changelog.html#0-3-1-2018-10-5","title":"Change Log - 0.3.1 (2018-10-5)","type":"extras"},{"doc":"Features: Support elixir 1.6","ref":"changelog.html#0-3-0-2018-10-5","title":"Change Log - 0.3.0 (2018-10-5)","type":"extras"},{"doc":"Bug Fixes: remove branch from changelog","ref":"changelog.html#0-2-3-2018-10-5","title":"Change Log - 0.2.3 (2018-10-5)","type":"extras"},{"doc":"Bug Fixes: inform of a safer tag push","ref":"changelog.html#0-2-2-2018-10-5","title":"Change Log - 0.2.2 (2018-10-5)","type":"extras"},{"doc":"Bug Fixes: Explain git tag pushing","ref":"changelog.html#0-2-1-2018-10-5","title":"Change Log - 0.2.1 (2018-10-5)","type":"extras"},{"doc":"Breaking Changes: Commit and tag, instead of tag and commit","ref":"changelog.html#0-2-0-2018-10-5","title":"Change Log - 0.2.0 (2018-10-5)","type":"extras"},{"doc":"Bug Fixes: Changelog: Spacing between beginning and body Split version and changelog commits","ref":"changelog.html#0-1-1-2018-10-5","title":"Change Log - 0.1.1 (2018-10-5)","type":"extras"},{"doc":"Bug Fixes: Split version and changelog commits","ref":"changelog.html#0-1-1-rc0-2018-10-5","title":"Change Log - 0.1.1-rc0 (2018-10-5)","type":"extras"},{"doc":"Breaking Changes: Parser: finalize initial parser Parser: Adding a basic commit parser BREAKING CHANGE: This header serves as an example. This footer serves as another example. Features: Version: rc and pre_release functionality Manage readme + mix.exs version numbers Changelog: Add version incrementing changelog: initial changelog writing CLI: Add basic release command (non-functional as of yet) Bug Fixes: Version: Get version from mix on init allow --initial again newline headings spacing in changelog Changelog: Correctly tag new versions Changelog: Don't show ! in the changelog Changelog: semicolons in scopeless commits Changelog: Fix changelog formatting parser: recognize exlamation points","ref":"changelog.html#0-1-0-2018-10-5","title":"Change Log - 0.1.0 (2018-10-5)","type":"extras"}]